<!-- Convert TiVo "now playing" XML to Atom 1.0. 
	  Bob DuCharme 2006-01-20 no warrantee expressed or implied. -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
					 xmlns:a="http://www.w3.org/2005/Atom"
					 xmlns:t="http://www.tivo.com/developer/calypso-protocol-1.5/"
					 xmlns:h="http://www.w3.org/1999/xhtml"
					 xmlns:date="http://exslt.org/dates-and-times"
					 xmlns:exsl="http://exslt.org/common"
					 extension-element-prefixes="date exsl"
					 exclude-result-prefixes="a h"
					 version="1.0">

  <xsl:strip-space elements="*"/>
  <xsl:output indent="yes" omit-xml-declaration="yes"/>

  <xsl:template match="t:TiVoContainer">
	 <feed xmlns="http://www.w3.org/2005/Atom">
		<a:title>TiVo: Now Playing</a:title>
		<a:updated><xsl:value-of select="date:date-time()"/></a:updated>
		<a:generator uri="http://www.snee.com/rss/bin/nowplaying2atom.xsl/">
		nowplaying2atom</a:generator>
		<a:link rel="self" type="application/atom+xml"
				  href="http://www.snee.com/rss/nowplaying.atom" />
		<a:id>tag:www.snee.com,2006:/tivo/</a:id>

		<xsl:apply-templates select="t:Item"/>
	 </feed>
  </xsl:template>


  <xsl:template match="t:Item">
	 <a:entry>
		<a:id>http://www.tivo.com/ns/ProgramId/<xsl:value-of select="t:Details/t:ProgramId"/></a:id>
		<a:title><xsl:apply-templates select="t:Details/t:Title"/></a:title>
		<a:updated><xsl:value-of select="date:date-time()"/></a:updated>
		<!-- URL format is a reverse-engineered hack that only works sometimes. -->
		<a:link rel="alternate"
				  href="https://www3.tivo.com/tivo-tco/program/show.do?show_id={t:Details/t:SeriesId}0000"/>
		<a:content type="text">

		  <xsl:if test="t:Details/t:EpisodeTitle">
			 <xsl:value-of select="normalize-space(t:Details/t:EpisodeTitle)"/>
			 <xsl:text>: </xsl:text>
		  </xsl:if>

		  <xsl:value-of select="t:Details/t:Description"/>
		</a:content>
	 </a:entry>
  </xsl:template>

</xsl:stylesheet>
